styloexport/views.py
from pathlib import Path
from typing import Any, Tuple, Type, TypeVar, Union

import httpx
from flask import (
    Blueprint,
    abort,
    current_app,
    redirect,
    render_template,
    request,
    send_file,
    url_for,
)
from slugify import slugify
from werkzeug.wrappers.response import Response
from wtforms import validators

from .article import Article
from .corpus import Corpus
from .forms import (
    ArticleForm,
    EditionForm,
    ExportForm,
    ExportGeneriqueForm,
    ExportRevueForm,
)
from .pandocapi import PandocAPI
from .utils import get_bibliographic_styles, get_domain_from_url, get_env_var

blueprint = Blueprint("views", __name__)
E = TypeVar("E", bound=ExportForm)

fake_path = Path()
pandocapi = PandocAPI(fake_path, fake_path, fake_path)


@blueprint.route("/", methods=("GET", "POST"))
def index() -> Union[str, Response]:
    editions = current_app.config.get("SE_EDITIONS", [])
    form = EditionForm()
    editions_choices = [(slug, metadata["name"]) for slug, metadata in editions.items()]
    form.edition.choices = editions_choices

    if form.validate_on_submit():
        edition = form.edition.data

        return redirect(url_for("views.edition", edition=edition))

    return render_template("index.html", **{"form": form, "editions": editions_choices})


@blueprint.route("/<edition>/", methods=("GET", "POST"))
def edition(edition: str) -> Union[str, Response]:
    SE_ALLOWED_INSTANCE_BASE_URLS_STR = get_env_var("SE_ALLOWED_INSTANCE_BASE_URLS")
    SE_ALLOWED_INSTANCE_BASE_URLS = SE_ALLOWED_INSTANCE_BASE_URLS_STR.split(" ")

    form = ArticleForm()
    form.domain.choices = [
        (get_domain_from_url(url), get_domain_from_url(url))
        for url in SE_ALLOWED_INSTANCE_BASE_URLS
    ]

    if form.validate_on_submit():
        slug = slugify(form.name.data, lowercase=False)
        kind = form.kind.data
        domain = form.domain.data
        id = form.article_id.data
        with_toc = form.with_toc.data
        with_ascii = form.with_ascii.data
        with_link_citations = form.with_link_citations.data
        with_nocite = form.with_nocite.data

        return redirect(
            url_for(
                f"views.{kind}",
                edition=edition,
                domain=domain,
                id=id,
                slug=slug,
                with_toc=1 if with_toc else 0,
                with_ascii=1 if with_ascii else 0,
                with_link_citations=1 if with_link_citations else 0,
                with_nocite=1 if with_nocite else 0,
            )
        )

    return render_template(
        "edition.html",
        **{
            "edition": edition,
            "form": form,
        },
    )


def get_article(
    edition: str,
    domain: str,
    article_id: str,
    article_slug: str,
    editions: dict,
    edition_configuration: dict,
    force_download: bool,
) -> Article:
    SE_ALLOWED_INSTANCE_BASE_URLS_STR = get_env_var("SE_ALLOWED_INSTANCE_BASE_URLS")
    SE_ALLOWED_INSTANCE_BASE_URLS = SE_ALLOWED_INSTANCE_BASE_URLS_STR.split(" ")
    SE_DOWNLOAD_DIR = current_app.config["SE_DOWNLOAD_DIR"]
    SE_SUPPORTED_IMAGES_EXTENSIONS = current_app.config.get(
        "SE_SUPPORTED_IMAGES_EXTENSIONS", []
    )
    templates_folder = (Path() / "templates" / edition).resolve()
    article_title = ""
    article = Article(
        edition,
        edition_configuration,
        domain,
        article_id,
        article_slug,
        article_title,
        SE_DOWNLOAD_DIR,
        list(editions.keys()),
        SE_ALLOWED_INSTANCE_BASE_URLS,
        SE_SUPPORTED_IMAGES_EXTENSIONS,
    )
    article.fetch_all(templates_folder, force=force_download)
    return article


def get_form(
    edition: str, article: Article, edition_configuration: dict
) -> Union[ExportGeneriqueForm, ExportRevueForm]:
    is_generic = edition == "generique"
    form_class: Type[Union[ExportGeneriqueForm, ExportRevueForm]] = (
        ExportGeneriqueForm if is_generic else ExportRevueForm
    )
    form = form_class(formdata=request.args)

    if is_generic:
        formats_choices = edition_configuration["exports"]
    else:
        formats_choices = [
            (slug, metadata["name"])
            for slug, metadata in edition_configuration["exports"].items()
        ]
    form.formats.choices = formats_choices

    if "bibliography_style" in form:
        bibliography_styles = get_bibliographic_styles()
        form.bibliography_style.choices = {
            category: [(item[0], item[1]) for item in items]
            for category, items in bibliography_styles.items()
        }

    version_choices = [("", "Version la plus récente")]
    for version in article.versions:
        version_label = (
            f"{version['message'] or 'Version sans nom'} "
            f"- {version['version']}.{version['revision']}"
        )
        version_choices.append((version["_id"], version_label))

    form.version.choices = version_choices
    # Dynamic validator because allowed version values are dynamic.
    form.version.validators = [
        validators.AnyOf(
            values=list(dict(version_choices).keys()),
            message="Version incorrecte, choix possibles : %(values)s.",
        )
    ]

    return form


def generate_bibliography(
    article: Article, form: Union[ExportGeneriqueForm, ExportRevueForm]
) -> Tuple[str, str]:
    bibliography_excerpt = ""
    bibliography_preview = ""

    if "bibliography_style" in form and not article.errors:

        def get_only_first_entries(
            content: str, separator: str = "\n\n", number: int = 3
        ) -> str:
            splited = content.split(separator, number)
            return separator.join(splited[:number])

        bibliography_excerpt = get_only_first_entries(
            article.bib_original_filepath.read_text()
        )

        if bibliography_excerpt.strip():
            try:
                bibliography_style = "chicagomodified"
                response = pandocapi.bibliography(
                    bibliography_excerpt,
                    bibliography_style,
                    current_app.config["SE_STYLES_DIR"] / f"{bibliography_style}.csl",
                )
                bibliography_preview = response.content.decode()
            except httpx.HTTPError:
                bibliography_preview = "La génération de la prévisualisation a échoué."

    return bibliography_excerpt, bibliography_preview


@blueprint.route("/<edition>/article/<domain>/<id>/<slug>/", methods=("GET",))
def article(edition: str, domain: str, id: str, slug: str) -> str:
    force_download = bool(request.args.get("force_download", False))
    editions = current_app.config["SE_EDITIONS"]
    edition_configuration = editions[edition]
    article = get_article(
        edition, domain, id, slug, editions, edition_configuration, force_download
    )
    form = get_form(edition, article, edition_configuration)
    bibliography_excerpt, bibliography_preview = generate_bibliography(article, form)

    return render_template(
        "article.html",
        **{
            "article": article,
            "bibliography_excerpt": bibliography_excerpt,
            "bibliography_preview": bibliography_preview,
            "form": form,
        },
    )


@blueprint.route("/<edition>/article/export/<domain>/<id>/<slug>/", methods=("GET",))
def export_article(edition: str, domain: str, id: str, slug: str) -> Any:
    force_download = bool(request.args.get("force_download", False))
    editions = current_app.config["SE_EDITIONS"]
    edition_configuration = editions[edition]
    article = get_article(
        edition,
        domain,
        id,
        slug,
        editions,
        edition_configuration,
        force_download,
    )
    form = get_form(edition, article, edition_configuration)
    if form.validate():
        version = form.version.data
        with_toc = form.with_toc.data
        with_ascii = form.with_ascii.data
        with_link_citations = form.with_link_citations.data
        with_nocite = form.with_nocite.data
        format_kind = form.formats.data
        templates_folder = (Path() / "templates" / edition).resolve()
        if edition == "generique":
            formats = format_kind
            style_name = form.bibliography_style.data
        else:
            formats = edition_configuration["exports"][format_kind]["formats"]
            csl_file_path = next(templates_folder.glob("*.csl"))
            style_name = csl_file_path.stem
        export_file_path = article.export(
            version,
            formats,
            style_name,
            templates_folder,
            with_toc=with_toc,
            with_ascii=with_ascii,
            with_link_citations=with_link_citations,
            with_nocite=with_nocite,
        )
        if article.errors:
            return render_template("article.html", **{"article": article, "form": form})
    else:
        return render_template("article.html", **{"article": article, "form": form})

    return send_file(export_file_path, as_attachment=True)


@blueprint.route(
    "/<edition>/article/downloads/<domain>/<id>/<slug>/<path:filename>",
    methods=("GET",),
)
def download_article(
    edition: str, domain: str, id: str, slug: str, filename: str
) -> Any:
    download_dir = (Path("..") / current_app.config["SE_DOWNLOAD_DIR"]).resolve()
    download_file_path = (
        download_dir / edition / domain / "articles" / f"{slug}-{id}" / filename
    )
    if not download_file_path.exists():
        return abort(404)

    return send_file(download_file_path, as_attachment=True)


def get_corpus(
    edition: str,
    domain: str,
    corpus_id: str,
    corpus_slug: str,
    editions: dict,
    edition_configuration: dict,
    force_download: bool,
) -> Corpus:
    SE_ALLOWED_INSTANCE_BASE_URLS_STR = get_env_var("SE_ALLOWED_INSTANCE_BASE_URLS")
    SE_ALLOWED_INSTANCE_BASE_URLS = SE_ALLOWED_INSTANCE_BASE_URLS_STR.split(" ")

styloexport/templates/article.html
{% extends 'base.html' %}

{% block extra_head %}
<style type="text/css">
    fieldset {
        border: 1px solid var(--border);
        border-radius: 5px;
        margin: 0.5rem 0;
    }
    select {
        width: 100%;
    }
    output[data-target="preview"] {
        display: block;
        background-color: var(--bg);
        border-radius: 5px;
        padding: 1rem;
    }
</style>
{% endblock extra_head %}

{% block main %}
    {% if article.errors %}
        <div class="errors">
            {% for error in article.errors %}
                <p>{{ error }}</p>
            {% endfor %}
        </div>
    {% else %}
        <h2>{{ article.metadata.title }}</h2>
        {% if article.metadata.abstract %}
            <blockquote>
                <p>{{ article.metadata.abstract }}</p>
            </blockquote>
        {% endif %}
        {% if article.images %}
            <details>
                <summary>Images</summary>
                {% for image in article.images %}
                    <figure>
                        <img alt="{{ image.alt }}" src="{{ url_for('views.download_article', edition=article.edition, domain=article.domain_slug, id=article.id, slug=article.slug, filename=image.config_path+'/'+image.name) }}" loading="lazy" />
                        <figcaption>
                            {{ image.title or image.alt }}
                            (origine : <a href="{{ image.url }}">{{ image.url }}</a>)
                        </figcaption>
                    </figure>
                {% endfor %}
            </details>
        {% endif %}
        <h3>Exports</h3>
        <form method="GET"
            action="{{ url_for('views.export_article', edition=article.edition, domain=article.domain, id=article.id, slug=article.slug) }}"
            {% if form.errors %}class="errors"{% endif %}
            >
            {{ form.with_toc }}
            {{ form.with_ascii }}
            {{ form.with_link_citations }}
            {{ form.with_nocite }}
            <fieldset>
                {% if form.version.errors %}
                    <div class="errors">
                        {% for error in form.version.errors %}
                            <p>{{ error }}</p>
                        {% endfor %}
                    </div>
                {% endif %}
                {{ form.version.label }} :<br />
                {{ form.version }}
            </fieldset>
            {% if form.bibliography_style %}
                <fieldset>
                    {{ form.bibliography_style.label }} :<br />
                    {{ form.bibliography_style(data_action="preview#update") }}
                    <br />
                    <p>Prévisualisation du rendu bibliographique (3 premiers items) :</p>
                    <output data-target="preview">
                        {{ bibliography_preview|safe }}
                    </output>
                </fieldset>
            {% endif %}

            {% if form.formats.choices %}
                <fieldset>
                    {% if form.formats.errors %}
                        <div class="errors">
                            {% for error in form.formats.errors %}
                                <p>{{ error }}</p>
                            {% endfor %}
                        </div>
                    {% endif %}
                    {{ form.formats.label }} :<br />
                    {{ form.formats }}
                </fieldset>
            {% endif %}
            <input type="submit" value="Télécharger">
        </form>
        <template>
            <pre>
                {{ article.bib_original_file_content }}
            </pre>
        </template>
    {% endif %}
{% endblock main %}

{% block extra_body %}
<script type="application/vnd.citationstyles.style+xml"
    data-target="excerpt">{{ bibliography_excerpt }}</script>

<script type="text/javascript">
    function onload() {
        const previewTarget = document.querySelector('[data-target="preview"]')
        const excerptTarget = document.querySelector('[data-target="excerpt"]')
        const select = document.querySelector('[data-action="preview#update"]')

        select.addEventListener('change', update)

        function checkStatus(response) {
            if (response.status >= 200 && response.status < 300) {
                return response
            } else {
                const error = new Error(response.statusText)
                error.response = response
                previewTarget.innerHTML = `
                    <p>La génération de la prévisualisation a échoué…</p>
                `
                throw error
            }
        }

        function update(event) {
            previewTarget.innerHTML = `
                <p>Génération de la prévisualisation en cours…</p>
            `
            const data = new FormData()
            data.append('excerpt', excerptTarget.textContent)
            data.append('bibliography_preview', select.value)
            fetch('/api/bibliography_preview', {
                method: 'POST',
                body: data
            })
            .then(checkStatus)
            .then((response) => response.text())
            .then((content) => {
                previewTarget.innerHTML = content
            })
        }

        // Otherwise, when refreshing the page, the selection becomes
        // out of sync because the browser keep the select to the latest
        // choice (at least Firefox).
        update()

        // Clean up
        document.removeEventListener('DOMContentLoaded', onload)
    }

    if (document.readyState != 'loading') {
        onload()
    } else {
        document.addEventListener('DOMContentLoaded', onload)
    }
</script>
{% endblock extra_body %}

styloexport/templates/base.html
<!doctype html><!-- This is a valid HTML5 document. -->
<!-- Screen readers, SEO, extensions and so on. -->
<html lang="fr">
<head>
  <!-- Has to be within the first 1024 bytes, hence before the `title` element
    See: https://www.w3.org/TR/2012/CR-html5-20121217/document-metadata.html#charset -->
  <meta charset="utf-8">
  <!-- Why no `X-UA-Compatible` meta: https://stackoverflow.com/a/6771584 -->
  <!-- The viewport meta is quite crowded and we are responsible for that.
    See: https://codepen.io/tigt/post/meta-viewport-for-2015 -->
  <meta name="viewport" content="width=device-width,initial-scale=1">
  <!-- Required to make a valid HTML5 document. -->
  <title>Stylo export</title>
  <link rel="stylesheet" href="{{ url_for('static', filename='vendors/css/nord.0.2.0.css') }}">
  <link rel="stylesheet" href="{{ url_for('static', filename='vendors/css/simple.2.0.2.css') }}">
  <link rel="stylesheet" href="{{ url_for('static', filename='css/colors.css') }}">
  <link rel="stylesheet" href="{{ url_for('static', filename='css/fonts.css') }}">
  <link rel="stylesheet" href="{{ url_for('static', filename='css/base.css') }}">
  <link rel="stylesheet" href="{{ url_for('static', filename='css/forms.css') }}">
  <link rel="stylesheet" href="{{ url_for('static', filename='css/errors.css') }}">
  <link rel="shortcut icon" href="{{ url_for('static', filename='favicon.ico') }}">
  {% block extra_head %}{% endblock extra_head %}
</head>
<body>
  <header>
  {% block header %}
    <h1><a href="/" title="Retourner à l’accueil">Stylo export</a></h1>
  {% endblock header %}
  </header>
  <main>
  {% block main %}

  {% endblock main %}
  </main>
  {% block extra_body %}{% endblock extra_body %}
</body>
</html>

styloexport/templates/corpus.html
{% extends 'base.html' %}

{% block extra_head %}
<style type="text/css">
    fieldset {
        border: 1px solid var(--border);
        border-radius: 5px;
        margin: 0.5rem 0;
    }
    select {
        width: 100%;
    }
    output[data-target="preview"] {
        display: block;
        background-color: var(--bg);
        border-radius: 5px;
        padding: 1rem;
    }
</style>
{% endblock extra_head %}

{% block main %}
    {% if corpus.errors %}
        <div class="errors">
            {% for error in corpus.errors %}
                <p>{{ error }}</p>
            {% endfor %}
        </div>
    {% else %}
        <h2>{{ corpus.metadata.title }}</h2>
        {% if corpus.metadata.abstract %}
            <blockquote>
                <p>{{ corpus.metadata.abstract }}</p>
            </blockquote>
        {% endif %}
        <h3>Export du corpus « {{ corpus.name }} »</h3>
        <p>Liste des articles exportés :</p>
        <ul>
        {% for article in corpus.articles %}
            <li><a href="//{{ domain }}/article/{{ article.id }}">{{ article.title }}</a></li>
        {% endfor %}
        </ul>
        <form method="GET"
            action="{{ url_for('views.export_corpus', edition=corpus.edition, domain=corpus.domain, id=corpus.id, slug=corpus.slug) }}"
            {% if form.errors %}class="errors"{% endif %}
            >
            {% if form.errors %}
                <div class="errors">
                    {% for error in form.errors %}
                        <p>{{ error }}</p>
                    {% endfor %}
                </div>
            {% endif %}
            {{ form.with_toc }}
            {{ form.with_ascii }}
            {{ form.with_link_citations }}
            {{ form.with_nocite }}
            <input type="text" name="version" value="" hidden>
            {% if form.bibliography_style %}
                <fieldset>
                    {{ form.bibliography_style.label }} :<br />
                    {{ form.bibliography_style(data_action="preview#update") }}
                    <br />
                    <p>Prévisualisation du rendu bibliographique (3 premiers items) :</p>
                    <output data-target="preview">
                        {{ bibliography_preview|safe }}
                    </output>
                </fieldset>
            {% endif %}

            {% if form.formats.choices %}
                <fieldset>
                    {% if form.formats.errors %}
                        <div class="errors">
                            {% for error in form.formats.errors %}
                                <p>{{ error }}</p>
                            {% endfor %}
                        </div>
                    {% endif %}
                    {{ form.formats.label }} :<br />
                    {{ form.formats }}
                </fieldset>
            {% endif %}
            <input type="submit" value="Télécharger">
        </form>
        <template>
            <pre>
                {{ corpus.bib_original_file_content }}
            </pre>
        </template>
    {% endif %}
{% endblock main %}

{% block extra_body %}
<script type="application/vnd.citationstyles.style+xml"
    data-target="excerpt">{{ bibliography_excerpt }}</script>

<script type="text/javascript">
    function onload() {
        const previewTarget = document.querySelector('[data-target="preview"]')
        const excerptTarget = document.querySelector('[data-target="excerpt"]')
        const select = document.querySelector('[data-action="preview#update"]')

        select.addEventListener('change', update)

        function checkStatus(response) {
            if (response.status >= 200 && response.status < 300) {
                return response
            } else {
                const error = new Error(response.statusText)
                error.response = response
                previewTarget.innerHTML = `
                    <p>La génération de la prévisualisation a échoué…</p>
                `
                throw error
            }
        }

        function update(event) {
            previewTarget.innerHTML = `
                <p>Génération de la prévisualisation en cours…</p>
            `
            const data = new FormData()
            data.append('excerpt', excerptTarget.textContent)
            data.append('bibliography_preview', select.value)
            fetch('/api/bibliography_preview', {
                method: 'POST',
                body: data
            })
            .then(checkStatus)
            .then((response) => response.text())
            .then((content) => {
                previewTarget.innerHTML = content
            })
        }

        // Otherwise, when refreshing the page, the selection becomes
        // out of sync because the browser keep the select to the latest
        // choice (at least Firefox).
        update()

        // Clean up
        document.removeEventListener('DOMContentLoaded', onload)
    }

    if (document.readyState != 'loading') {
        onload()
    } else {
        document.addEventListener('DOMContentLoaded', onload)
    }
</script>
{% endblock extra_body %}

styloexport/templates/edition.html
{% extends 'base.html' %}

{% block main %}
    <form
        method="POST"
        action="{{ url_for('views.edition', edition=edition) }}"
        {% if form.errors %}class="errors"{% endif %}
    >
        {{ form.csrf_token }}
        {{ form.name.label }} :<br />
        {{ form.name }}
        {% if form.name.errors %}
            <dl>
            {% for error in form.name.errors %}
                <dt>Erreur :</dt>
                <dd>{{ error|safe }}</dd>
            {% endfor %}
            </dl>
        {% endif %}
        <br />
        {{ form.kind.label }} :<br />
        {{ form.kind }}
        {% if form.kind.errors %}
            <dl>
            {% for error in form.kind.errors %}
                <dt>Erreur :</dt>
                <dd>{{ error|safe }}</dd>
            {% endfor %}
            </dl>
        {% endif %}
        <br />
        {{ form.domain.label }} :<br />
        {{ form.domain }}
        {% if form.domain.errors %}
            <dl>
            {% for error in form.domain.errors %}
                <dt>Erreur :</dt>
                <dd>{{ error|safe }}</dd>
            {% endfor %}
            </dl>
        {% endif %}
        <br />
        {{ form.article_id.label }} :<br />
        {{ form.article_id }}
        <p style="margin-top: 0;"><small>Par exemple <code>5e32d54e4f58270018f9d251</code></small></p>
        {% if form.article_id.errors %}
            <dl>
            {% for error in form.article_id.errors %}
                <dt>Erreur :</dt>
                <dd>{{ error|safe }}</dd>
            {% endfor %}
            </dl>
        {% endif %}
        {{ form.with_toc }} {{ form.with_toc.label }}<br />
        {{ form.with_ascii }} {{ form.with_ascii.label }}<br />
        {{ form.with_link_citations }} {{ form.with_link_citations.label }}<br />
        {{ form.with_nocite }} {{ form.with_nocite.label }}
        <input type="submit" value="Récupérer">
    </form>
{% endblock main %}

styloexport/templates/index.html
{% extends 'base.html' %}

{% block main %}
    <form
        method="POST"
        action="{{ url_for('views.index') }}"
        {% if form.errors %}class="errors"{% endif %}
    >
        {{ form.csrf_token }}
        {{ form.edition.label }} :<br />
        {{ form.edition }}
        <input type="submit" value="Poursuivre">
    </form>
{% endblock main %}